package kernel.ui;

import lib.Pos;
import lib.Color;
import lib.Vec.Vec2;

using tink.CoreApi;

/**
	Interface describing a terminal. E.g. the main computer screen or a external screen.
**/
interface TermWriteable {
	public var onResize(default, null):Signal<Vec2<Int>>;

	public function write(text:String):Void;
	public function scroll(y:Int):Void;

	/**
		Even though CC is 1 based we use a 0 based index.
	**/
	public function getCursorPos():Pos;

	/**
		Even though CC is 1 based we use a 0 based index.
	**/
	public function setCursorPos(x:Int, y:Int):Void;

	public function getCursorBlink():Bool;
	public function setCursorBlink(blink:Bool):Void;
	public function getSize():Vec2<Int>;
	public function clear():Void;
	public function clearLine():Void;
	public function getTextColor():Color;
	public function setTextColor(color:Color):Void;
	public function getBackgroundColor():Color;
	public function setBackgroundColor(color:Color):Void;
	public function isColor():Bool;
	// public function setPaletteColor(...);
	// public function getPaletteColor(color);

	/**
		Clears the screen, resetes the courser to (0,0) and resetes the color to Black and White.
	**/
	public function reset():Void;
}
